#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# sound_menu V1.3p (15/05/2008)
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import es, os, re, psyco, popuplib, playerlib as _pl
from FileAnalyse import FileAnalyse as _fa
from BuildMenu import BuildMenu as _bm

psyco.full()
sm_info = es.AddonInfo()
sm_info.version = "1.3p"
sm_info.author = "DoCky"
sm_info.name = "sound_menu"
sm_info.url = "http://addons.eventscripts.com/addons/user/11751"
sm_path = es.ServerVar('eventscripts_gamedir') + "/cfg/sound_menu/"




#    SYSTEM    #
class System:
    """
        System
    """

    _cv_vers = es.ServerVar("sound_menu", "1.3p", "script version")
    _cv_lang = es.ServerVar("sm_lang")
    _cv_user = es.ServerVar("sm_user")
    _cv_cmnd = es.ServerVar("sm_cmnd")
    _cv_down = es.ServerVar("sm_down")
    _cv_stic = es.ServerVar("sm_stic")

    _info = {"cmd" : []}
    _list = {}
    _menu = {}
    _user = {}
    _stop = {}


    @staticmethod
    def loadConf():
        System._cv_vers.set(sm_info.version)
        System._cv_vers.makepublic()

        if not os.path.isdir(sm_path):
            os.mkdir(sm_path)

        if not os.path.isdir("%ssoundlist/" % sm_path):
            os.mkdir("%ssoundlist/" % sm_path)

        if not os.path.isdir("%slanguage/" % sm_path):
            os.mkdir("%slanguage/" % sm_path)

        if not os.path.isfile("%sconfig.cfg" % sm_path):
            es.log("[sound_menu] missing file : cfg/sound_menu/config.cfg")

        else:
            es.server.cmd("es_xmexec sound_menu/config.cfg")

            if not os.path.isfile("%slanguage/%s.txt" % (sm_path, System._cv_lang)):
                es.log("[sound_menu] missing file : cfg/sound_menu/language/%s.cfg" % System._cv_lang)

            else:
                System.langList()

                if len(System._info["lge"]) != 17:
                    es.log("[sound_menu] file : !warning! file corrupted")
                    es.log("[sound_menu] path : cfg/sound_menu/%s.cfg" % System._cv_lang)

                else:
                    List = filter(re.compile(".*\.txt$").search, os.listdir("%ssoundlist/" % sm_path))
                    List.sort()

                    if not len(List):
                        es.log("[sound_menu] file : !warning! sound list missing")
                        es.log("[sound_menu] path : cfg/sound_menu/soundlist/*")

                    else:
                        System.sonsList(List)

                        if not len(System._list):
                            es.log("[sound_menu] file : !warning! file corrupted")
                            es.log("[sound_menu] path : cfg/sound_menu/soundlist/*")

                        else:
                            es.log("[sound_menu] * loading config *")
                            es.log("[sound_menu] SM lang : %s" % System._cv_lang)
                            System.userList()

                            if not len(System._info["adm"]):
                                es.log("[sound_menu] id list : !warning! no user registered")

                            else:
                                es.log("[sound_menu] id list : " + re.sub("[[']|]", "", str(System._info["adm"])))
                                System.loadCmnd("create")

                                if not len(System._info["cmd"]):
                                    es.log("[sound_menu] command : !warning! no command registered")

                                else:
                                    es.log("[sound_menu] command : " + re.sub("[[']|]", "", str(System._info["cmd"])))

                                    if not int(System._cv_down):
                                        es.log("[sound_menu] dl file : Off")

                                    else:
                                        es.log("[sound_menu] dl file : On")
                                        System.downLoad()

                                    es.log("[sound_menu] * config loaded *")
                                    es.server.cmd("echo")
                                    return True


    @staticmethod
    def langList():
        System._info["lge"] = {}
        for line in _fa("%slanguage/%s.txt" % (sm_path, System._cv_lang)).getList():
            lang = line.split("=")

            if len(lang) == 2:
                System._info["lge"][lang[0].strip()] = lang[1].strip()


    @staticmethod
    def sonsList(List):
        System._info["typ"] = []
        System._info["snd"] = []

        for path in List:
            if path.strip():

                File = _fa("%ssoundlist/%s" % (sm_path, path.strip())).getList()
                File.sort()
                Dict = {}

                for line in File:
                    sons = line.split("=")
                    if len(sons) == 2:
                        Dict[sons[0].strip()] = sons[1].strip()

                        down = "sound/%s" % sons[1].strip()
                        if not down in System._info["snd"]:
                            System._info["snd"].append(down)

                if len(Dict):
                    Type = path.strip().replace(".txt", "")
                    System._list[Type] = Dict

                    if not Type in System._info["typ"]:
                        System._info["typ"].append(Type)


    @staticmethod
    def userList():
        System._info["adm"] = []
        for user in str(System._cv_user).split(","):
            if user and user != "0" and not user.strip() in System._info["adm"]:
                System._info["adm"].append(user.strip())


    @staticmethod
    def loadCmnd(fonc):
        if fonc == "create":
            for cmnd in str(System._cv_cmnd).split(","):

                if cmnd.strip() and cmnd.strip() != "0" and not cmnd in System._info["cmd"]:
                    if es.exists("clientcommand", cmnd.strip()):

                        es.log("[sound_menu] command allready exist : " + cmnd.strip())
                        es.log("[sound_menu] command will be reinitialized : " + cmnd.strip())
                        es.unregclientcmd(cmnd.strip())

                    System._info["cmd"].append(cmnd.strip())
                    es.regclientcmd(cmnd.strip(), "sound_menu/player_cmd", "acces menu command")

        elif fonc == "delete":
            for word in System._info["cmd"]:

                if es.exists("clientcommand", word):
                    es.unregclientcmd(word)

            if len(System._info["cmd"]):
                es.log("[sound_menu] commands deleted : " + re.sub("[[']|]", "", str(System._info["cmd"])))


    @staticmethod
    def downLoad():
        for path in System._info["snd"]:
            es.stringtable("downloadables", str(path))




#    POPUP    #
class Create:
    """
        Popup
    """


    # Static menu

    @staticmethod
    def loadMenu():
        try:
            es.log("[sound_menu] * Creating menu *")

            Create.__menu()
            Create.__team()
            Create.__type()
            Create.__sons()

            es.log("[sound_menu] menu has been created successfully")
            es.log("[sound_menu] * Menu created *")

        except:
            es.log("[sound_menu] !warning! menu could not be created")
            es.unload("sound_menu")


    @staticmethod
    def deleMenu():
        for menu in System._menu:
            if popuplib.exists(menu):
                popuplib.delete(menu)


    @staticmethod
    def __menu():
        System._menu["sm_menu"] = ""
        menu = popuplib.create("sm_menu")
        menu.addline(System._info["lge"]["sm_tittle_menu"])

        menu.addline("->1. %s" % System._info["lge"]["sm_option_type"])
        menu.addline("->2. %s" % System._info["lge"]["sm_option_user"])
        menu.addline("->3. %s" % System._info["lge"]["sm_option_team"])
        menu.addline("->4. %s" % System._info["lge"]["sm_option_stop"])

        menu.addline("0. %s" % System._info["lge"]["sm_action_exit"])

        if len(System._info["typ"]) > 1:
            menu.submenu(1, "sm_type_1")

        else:
            menu.submenu(1, "sm__%s_1" % System._info["typ"][0])

        if int(System._cv_stic):
            menu.submenu(4, "sm_menu")

        menu.submenu(3, "sm_team")
        menu.menuselect = Menu


    @staticmethod
    def __team():
        System._menu["sm_team"] = ""
        menu = popuplib.create("sm_team")
        menu.addline(System._info["lge"]["sm_tittle_team"])

        menu.addline("->1. %s" % System._info["lge"]["sm_option_anti"])
        menu.addline("->2. %s" % System._info["lge"]["sm_option_tero"])
        menu.addline("->3. %s" % System._info["lge"]["sm_option_spec"])

        menu.addline("9. %s" % System._info["lge"]["sm_action_menu"])
        menu.addline("0. %s" % System._info["lge"]["sm_action_exit"])

        if len(System._info["typ"]) > 1:
            sm_subt = "sm_type_1"

        else:
            sm_subt = "sm__%s_1" % System._info["typ"][0]

        menu.submenu(1, sm_subt)
        menu.submenu(2, sm_subt)
        menu.submenu(3, sm_subt)
        menu.submenu(9, "sm_menu")
        menu.menuselect = Team


    @staticmethod
    def __type():
        indp = 0
        File = System._info["typ"]
        page = _bm.getPage(len(File), 7)

        while indp < page:
            indp += 1
            name = "sm_type_%s" % indp
            System._menu[name] = ""

            menu = popuplib.create(name)
            menu.addline("%s    %s/%s" % (System._info["lge"]["sm_tittle_type"], indp, page))

            item = _bm.getItem(indp, page, len(File), 7)
            indi = 0

            while indi < item:
                indo = (indp - 1) * 7 + indi
                indi += 1

                menu.addline("->%s. %s" % (indi, File[indo]))
                menu.submenu(indi, "sm__%s_1" % File[indo])

            if indp < page:
                menu.addline("8. %s" % System._info["lge"]["sm_action_next"])
                menu.submenu(8, "sm_type_%s" % indp + 1)

            if indp == 1:
                menu.addline("9. %s" % System._info["lge"]["sm_action_menu"])
                menu.submenu(9, "sm_menu")

            else:
                menu.addline("9. %s" % System._info["lge"]["sm_action_back"])
                menu.submenu(9, "sm_type_%s" % indp - 1)

            menu.addline("0. %s" % System._info["lge"]["sm_action_exit"])


    @staticmethod
    def __sons():
        for Type in System._info["typ"]:
            List = System._list[Type]
            sons = List.keys()
            sons.sort()

            indp = 0
            page = _bm.getPage(len(sons), 7)
            while indp < page:
                indp += 1
                name = "sm__%s_%s" % (Type, indp)
                System._menu[name] = {}

                menu = popuplib.create(name)
                menu.addline("%s    %s/%s" % (Type, indp, page))

                item = _bm.getItem(indp, page, len(sons), 7)
                indi = 0

                while indi < item:
                    indo = (indp - 1) * 7 + indi
                    indi += 1

                    menu.addline("->%s. %s" % (indi, sons[indo]))
                    System._menu[name][indi] = List[sons[indo]]

                    if int(System._cv_stic):
                        menu.submenu(indi, name)

                if indp < page:
                    menu.addline("8. %s" % System._info["lge"]["sm_action_next"])
                    menu.submenu(8, "sm__%s_%i" % (Type, indp + 1))

                if indp == 1:
                    if len(System._info["typ"]) == 1:
                        menu.addline("9. %s" % System._info["lge"]["sm_action_menu"])
                        menu.submenu(9, "sm_menu")

                    else:
                        menu.addline("9. %s" % System._info["lge"]["sm_action_type"])
                        menu.submenu(9, "sm_type_1")

                else:
                    menu.addline("9. %s" % System._info["lge"]["sm_action_back"])
                    menu.submenu(9, "sm__%s_%i" % (Type, indp - 1))

                menu.addline("0. %s" % System._info["lge"]["sm_action_exit"])
                menu.menuselect = Play


    # Player menu

    @staticmethod
    def userMenu(user):
        List = []
        for User in _pl.getUseridList("#human"):
            List.append(es.getplayername(User))

        List.sort()
        Create.__user(user, List)
        popuplib.send("sm___%s_1" % user, user)


    @staticmethod
    def __user(user, List):
        indp = 0
        page = _bm.getPage(len(List), 6)

        while indp < page:
            indp += 1
            name = "sm___%s_%s" % (user, indp)
            System._menu[name] = {}

            menu = popuplib.create(name)
            menu.addline("%s    %s/%s" % (System._info["lge"]["sm_tittle_user"], indp, page))

            item = _bm.getItem(indp, page, len(List), 6)
            indi = 0

            while indi < item:
                indo = (indp - 1) * 6 + indi
                indi += 1

                menu.addline("->%s. %s" % (indi, List[indo]))
                System._menu[name][indi] = List[indo]
                menu.submenu(indi, name)

            if indp < page:
                menu.addline("7. %s" % System._info["lge"]["sm_action_vali"])
                System._menu[name]["vali"] = 7

                menu.addline("8. %s" % System._info["lge"]["sm_action_next"])
                menu.submenu(8, "sm___%s_%i" % (user, indp + 1))

            else:
                menu.addline("8. %s" % System._info["lge"]["sm_action_vali"])
                System._menu[name]["vali"] = 8

            if indp == 1:
                menu.addline("9. %s" % System._info["lge"]["sm_action_menu"])
                menu.submenu(9, "sm_menu")

            else:
                menu.addline("9. %s" % System._info["lge"]["sm_action_back"])
                menu.submenu(9, "sm___%s_%i" % (user, indp - 1))

            menu.addline("0. %s" % System._info["lge"]["sm_action_exit"])
            menu.menuselect = User




#    EVENT    #
def load():
    if System.loadConf():
        Create.loadMenu()

    else:
        es.unload("sound_menu")


def unload():
    Create.deleMenu()
    System.loadCmnd("delete")
    es.log("[sound_menu] sound menu has been unloaded")


def player_cmd():
    user = es.getcmduserid()
    usid = es.getplayersteamid(user)
    Cmnd(usid, user)


def player_say(event_var):
    if event_var["text"] in System._info["cmd"]:
        Cmnd(event_var["es_steamid"], int(event_var["userid"]))


def round_start(event_var):
    System._stop = {}


def es_map_start(event_var):
    Create.deleMenu()

    if System.loadConf():
        Create.loadMenu()

    else:
        es.unload("sound_menu")




#    MENU    #
def Cmnd(usid, user):
    if usid in System._info["adm"]:
        System._user[user] = {}
        System._user[user]["tag"] = []
        System._user[user]["nam"] = []

        name = popuplib.active(user)["name"]
        if not popuplib.isqueued(name, user):
            popuplib.send("sm_menu", user)

        else:
            popuplib.unsendname(name, user)


def Menu(userid, choice, popupid):
    if choice == 1:
        System._user[userid]["tag"] = ["#human"]

    elif choice == 2:
        System._user[userid]["nam"] = []
        Create.userMenu(userid)

    elif choice == 4:
        for user in System._stop:
            for path in System._stop[user]:
                es.stopsound(user, path)

        System._stop = {}


def User(userid, choice, popupid):
    if choice == System._menu[popupid]["vali"]:
        if not len(System._user[userid]["nam"]):
            popuplib.find(popupid).send(userid)

        elif len(System._info["typ"]) == 1:
            popuplib.send("sm__%s_1" % System._info["typ"][0], userid)

        else:
            popuplib.send("sm_type_1", userid)

    elif System._menu[popupid].has_key(choice):
        line = choice + 1
        menu = popuplib.find(popupid)
        name = System._menu[popupid][choice]

        if name in System._user[userid]["nam"]:
            System._user[userid]["nam"].remove(name)
            menu.modline(line, "->%s. %s" % (choice, name))

        else:
            System._user[userid]["nam"].append(name)
            menu.modline(line, "->%s. *%s" % (choice, name))


def Team(userid, choice, popupid):
    if choice == 1:
        System._user[userid]["tag"] = ["#human,#ct"]

    elif choice == 2:
        System._user[userid]["tag"] = ["#human,#t"]

    elif choice == 3:
        System._user[userid]["tag"] = ["#spec" ,"#un"]


def Play(userid, choice, popupid):
    if System._menu[popupid].has_key(choice):
        path = System._menu[popupid][choice]

        List = System._user[userid]["tag"]
        if len(List):
            for tags in List:

                for user in _pl.getUseridList(tags):
                    es.playsound(user, path, 1)
                    Stop(user, path)

        else:
            for name in System._user[userid]["nam"]:
                user = es.getuserid(name)

                if int(user):
                    es.playsound(user, path, 1)
                    Stop(user, path)


def Stop(user, path):
    if not user in System._stop:
        System._stop[user] = []

    System._stop[user].append(path)

#============================================================================================================================================#
